# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: services.proto for package 'gauge.messages'

require 'grpc'
require 'services_pb'

module Gauge
  module Messages
    module Runner
      class Service

        include GRPC::GenericService

        self.marshal_class_method = :encode
        self.unmarshal_class_method = :decode
        self.service_name = 'gauge.messages.Runner'

        # ValidateStep is a RPC to validate a given step.
        #
        # Accepts a StepValidateRequest message and returns a StepValidateResponse message
        rpc :ValidateStep, StepValidateRequest, StepValidateResponse
        # SuiteDataStoreInit is a RPC to initialize the suite level data store.
        #
        # Accepts a Empty message and returns a ExecutionStatusResponse message
        rpc :InitializeSuiteDataStore, Empty, ExecutionStatusResponse
        # ExecutionStarting is a RPC to tell runner to execute Suite level hooks.
        #
        # Accepts a ExecutionStartingRequest message and returns a ExecutionStatusResponse message
        rpc :StartExecution, ExecutionStartingRequest, ExecutionStatusResponse
        # SpecDataStoreInit is a RPC to initialize the spec level data store.
        #
        # Accepts a Empty message and returns a ExecutionStatusResponse message
        rpc :InitializeSpecDataStore, Empty, ExecutionStatusResponse
        # SpecExecutionStarting is a RPC to tell runner to execute spec level hooks.
        #
        # Accepts a SpecExecutionStartingRequest message and returns a ExecutionStatusResponse message
        rpc :StartSpecExecution, SpecExecutionStartingRequest, ExecutionStatusResponse
        # ScenarioDataStoreInit is a RPC to initialize the scenario level data store.
        #
        # Accepts a Empty message and returns a ExecutionStatusResponse message
        rpc :InitializeScenarioDataStore, Empty, ExecutionStatusResponse
        # ScenarioExecutionStarting is a RPC to tell runner to execute scenario level hooks.
        #
        # Accepts a ScenarioExecutionStartingRequest message and returns a ExecutionStatusResponse message
        rpc :StartScenarioExecution, ScenarioExecutionStartingRequest, ExecutionStatusResponse
        # StepExecutionStarting is a RPC to tell runner to execute step level hooks.
        #
        # Accepts a StepExecutionStartingRequest message and returns a ExecutionStatusResponse message
        rpc :StartStepExecution, StepExecutionStartingRequest, ExecutionStatusResponse
        # ExecuteStep is a RPC to tell runner to execute a step .
        #
        # Accepts a ExecuteStepRequest message and returns a ExecutionStatusResponse message
        rpc :ExecuteStep, ExecuteStepRequest, ExecutionStatusResponse
        # StepExecutionEnding is a RPC to tell runner to execute step level hooks.
        #
        # Accepts a StepExecutionEndingRequest message and returns a ExecutionStatusResponse message
        rpc :FinishStepExecution, StepExecutionEndingRequest, ExecutionStatusResponse
        # ScenarioExecutionEnding is a RPC to tell runner to execute Scenario level hooks.
        #
        # Accepts a ScenarioExecutionEndingRequest message and returns a ExecutionStatusResponse message
        rpc :FinishScenarioExecution, ScenarioExecutionEndingRequest, ExecutionStatusResponse
        # SpecExecutionEnding is a RPC to tell runner to execute spec level hooks.
        #
        # Accepts a SpecExecutionEndingRequest message and returns a ExecutionStatusResponse message
        rpc :FinishSpecExecution, SpecExecutionEndingRequest, ExecutionStatusResponse
        # ExecutionEnding is a RPC to tell runner to execute suite level hooks.
        #
        # Accepts a ExecutionEndingRequest message and returns a ExecutionStatusResponse message
        rpc :FinishExecution, ExecutionEndingRequest, ExecutionStatusResponse
        # CacheFile is a RPC to tell runner to load/reload/unload a implementation file.
        #
        # Accepts a CacheFileRequest message and returns a Empty message
        rpc :CacheFile, CacheFileRequest, Empty
        # GetStepName is a RPC to get information about the given step.
        #
        # Accepts a StepNameRequest message and returns a StepNameResponse message.
        rpc :GetStepName, StepNameRequest, StepNameResponse
        # GetGlobPatterns is a RPC to get the file path pattern which needs to be cached.
        #
        # Accepts a Empty message and returns a ImplementationFileGlobPatternResponse message.
        rpc :GetGlobPatterns, Empty, ImplementationFileGlobPatternResponse
        # GetStepNames is a RPC to get all the available steps from the runner.
        #
        # Accepts a StepNamesRequest message and returns a StepNamesResponse
        rpc :GetStepNames, StepNamesRequest, StepNamesResponse
        # GetStepPositions is a RPC to get positions of all available steps in a given file.
        #
        # Accepts a StepPositionsRequest message and returns a StepPositionsResponse message
        rpc :GetStepPositions, StepPositionsRequest, StepPositionsResponse
        # GetImplementationFiles is a RPC get all the existing implementation files.
        #
        # Accepts a Empty and returns a ImplementationFileListResponse message.
        rpc :GetImplementationFiles, Empty, ImplementationFileListResponse
        # ImplementStub is a RPC to to ask runner to add a given implementation to given file.
        #
        # Accepts a StubImplementationCodeRequest and returns a FileDiff message.
        rpc :ImplementStub, StubImplementationCodeRequest, FileDiff
        # Refactor is a RPC to refactor a given step in implementation file.
        #
        # Accepts a RefactorRequest message and returns a RefactorResponse message.
        rpc :Refactor, RefactorRequest, RefactorResponse
        # Kill is a RPC tell plugin to stop grpc server and kill the plugin process.
        #
        # Accepts a KillProcessRequest message and returns a Empty message.
        rpc :Kill, KillProcessRequest, Empty
      end

      Stub = Service.rpc_stub_class
    end
    module Reporter
      # Reporter services is meant for reporting plugins, or others plugins which are interested the live events
      class Service

        include GRPC::GenericService

        self.marshal_class_method = :encode
        self.unmarshal_class_method = :decode
        self.service_name = 'gauge.messages.Reporter'

        # NotifyExecutionStarting is a RPC to tell plugins that the execution has started.
        #
        # Accepts a ExecutionStartingRequest message and returns a Empty message
        rpc :NotifyExecutionStarting, ExecutionStartingRequest, Empty
        # NotifySpecExecutionStarting is a RPC to tell plugins that the specification execution has started.
        #
        # Accepts a SpecExecutionStartingRequest message and returns a Empty message
        rpc :NotifySpecExecutionStarting, SpecExecutionStartingRequest, Empty
        # NotifyScenarioExecutionStarting is a RPC to tell plugins that the scenario execution has started.
        #
        # Accepts a ScenarioExecutionStartingRequest message and returns a Empty message
        rpc :NotifyScenarioExecutionStarting, ScenarioExecutionStartingRequest, Empty
        # NotifyStepExecutionStarting is a RPC to tell plugins that the step execution has started.
        #
        # Accepts a StepExecutionStartingRequest message and returns a Empty message
        rpc :NotifyStepExecutionStarting, StepExecutionStartingRequest, Empty
        # NotifyStepExecutionEnding is a RPC to tell plugins that the step execution has finished.
        #
        # Accepts a StepExecutionStartingRequest message and returns a Empty message
        rpc :NotifyStepExecutionEnding, StepExecutionEndingRequest, Empty
        # NotifyScenarioExecutionEnding is a RPC to tell plugins that the scenario execution has finished.
        #
        # Accepts a ScenarioExecutionEndingRequest message and returns a Empty message
        rpc :NotifyScenarioExecutionEnding, ScenarioExecutionEndingRequest, Empty
        # NotifySpecExecutionEnding is a RPC to tell plugins that the specification execution has finished.
        #
        # Accepts a SpecExecutionStartingRequest message and returns a Empty message
        rpc :NotifySpecExecutionEnding, SpecExecutionEndingRequest, Empty
        # NotifyExecutionEnding is a RPC to tell plugins that the execution has finished.
        #
        # Accepts a ExecutionEndingRequest message and returns a Empty message
        rpc :NotifyExecutionEnding, ExecutionEndingRequest, Empty
        # NotifySuiteResult is a RPC to tell about the end result of execution
        #
        # Accepts a SuiteExecutionResult message and returns a Empty message.
        rpc :NotifySuiteResult, SuiteExecutionResult, Empty
        # Kill is a RPC tell plugin to stop grpc server and kill the plugin process.
        #
        # Accepts a KillProcessRequest message and returns a Empty message.
        rpc :Kill, KillProcessRequest, Empty
      end

      Stub = Service.rpc_stub_class
    end
  end
end
